﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Arction.Wpf.Charting;
using Arction.Wpf.Charting.Annotations;
using Arction.Wpf.Charting.Series3D;

namespace AnnotationTest
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();

			this.initializePlot();
		}

		private void initializePlot()
		{
			this.chart.ActiveView = ActiveView.View3D;
			PointLineSeries3D line = new PointLineSeries3D(this.chart.View3D, Axis3DBinding.Primary, Axis3DBinding.Primary, Axis3DBinding.Primary);
			line.AddPoints(Enumerable.Range(0, 100).Select((point) => new SeriesPoint3D(point, point, point)).ToArray(), true);
			line.PointsOptimization = PointsRenderOptimization3D.Pixels;
			line.LineStyle.LineOptimization = LineOptimization.Hairline;
			this.chart.View3D.PointLineSeries3D.Add(line);
			this.chart.View3D.Annotations.Add(this.createAnnotation(Colors.Red, "first", line.Points[25]));
			this.chart.View3D.Annotations.Add(this.createAnnotation(Colors.Blue, "second", line.Points[75]));
		}

		private Annotation3D createAnnotation(Color color, string text, SeriesPoint3D target)
		{
			Annotation3D annotation = new Annotation3D(this.chart.View3D, Axis3DBinding.Primary, Axis3DBinding.Primary, Axis3DBinding.Primary);
			annotation.ShowTargetCrosshair = TargetCrossHair.On;
			annotation.TargetCrosshairLineStyle.Color = color;
			annotation.Text = text;
			annotation.TargetAxisValues = new PointDoubleXYZ(target.X, target.Y, target.Z);
			return annotation;
		}
	}
}
